import React from 'react';
import ReactDOM from 'react-dom';
import { useEffect, useState } from 'react';
import {
  json,
  geoPath,
  geoEqualEarth,
  geoCylindricalEqualArea,
  geoGraticule,
  line
} from 'd3';
import { feature, mesh } from 'topojson';

const width = 960;
const height = 500;

const App = () => {
  const [data, setData] = useState(null);
  const jsonUrl =
    'https://unpkg.com/world-atlas@2.0.2/countries-50m.json';

  useEffect(() => {
    json(jsonUrl).then((topology) => {
      console.log("topology");
      console.log(topology);
      const { countries, land } = topology.objects;
      console.log('tutaj');
      console.log(land);
      console.log(countries);
      console.log(topology.objects);
      setData({
        land: feature(topology, land),
        interiors: mesh(
          topology,
          countries,
          (a, b) => a !== b
        ),
      });
    });
  }, []);

  const proje = geoCylindricalEqualArea();
  const path = geoPath(proje);
  const graticule = geoGraticule();

  if (!data) {
    return <pre>Loading...</pre>;
  }
  
  console.log("tutaj2");
  console.log(data);

  const Globe = () => (
    <g className="marks">
      <path
        className="sphere"
        d={path({ type: 'Sphere' })}
      />
      <path className="graticule" d={path(graticule())} />
      {data.land.features.map((feature) => (
        <path className="land" d={path(feature)} />
      ))}
      <path
        className="interiors"
        d={path(data.interiors)}
      />
    </g>
  );

  return (
    <svg width={width} height={height}>
      <Globe/>
    </svg>
  );
};
const rootElement = document.getElementById('root');
ReactDOM.render(<App />, rootElement);
